﻿// cc-by 3.0 Austria, (c) 2011 Markus Loeberbauer
// http://ssw.jku.at/Teaching/Lectures/SpezialLVA/JavaFX/

import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.geometry.Pos;
import javafx.scene.SceneBuilder;
import javafx.scene.control.ButtonBuilder;
import javafx.scene.layout.VBoxBuilder;
import javafx.stage.Stage;

public class FullScreen extends Application {
  public static void main(String[] args) {
    Application.launch(args);
  }

  @Override
  public void start(final Stage primaryStage) {
    primaryStage.setTitle("Full Screen");

    primaryStage.setScene(SceneBuilder.create()
      .width(250)
      .height(120)
      .root(VBoxBuilder.create()
        .spacing(4)
        .alignment(Pos.CENTER)
        .children(
          ButtonBuilder.create()
          .text("Go Fullscreen")
          .onAction(
            new EventHandler<ActionEvent>() {
              @Override
              public void handle(ActionEvent event) {
                primaryStage.setFullScreen(true);
              }
            }
          )
          .build(),
          ButtonBuilder.create()
          .text("Go Window")
          .onAction(
            new EventHandler<ActionEvent>() {
              @Override
              public void handle(ActionEvent event) {
                primaryStage.setFullScreen(false);
              }
            }
          )
          .build()
        )
        .build()
      )
      .build()
    );
    
    primaryStage.show();
  }
}
