﻿// cc-by 3.0 Austria, (c) 2011 Markus Loeberbauer
// http://ssw.jku.at/Teaching/Lectures/SpezialLVA/JavaFX/
import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.SceneBuilder;
import javafx.scene.control.ButtonBuilder;
import javafx.scene.control.Hyperlink;
import javafx.scene.layout.VBox;
import javafx.scene.layout.VBoxBuilder;
import javafx.scene.text.Text;
import javafx.scene.text.TextBuilder;
import javafx.stage.Stage;

public class MultipleScenes extends Application {
  private Scene scene1, scene2;
  private Stage stage;
  
  
  public static void main(String[] args) {
    Application.launch(args);
  }
  
  
  @Override
  public void start(Stage primaryStage) {
    stage = primaryStage;
    
    primaryStage.setTitle("Multiple Scenes");
    primaryStage.setWidth(200);
    primaryStage.setHeight(200);

    initScenes();
    
    primaryStage.setScene(scene1);
    primaryStage.show();
  }
  
  private void initScenes() {
    initScene1DeclarativeStyle();
    initScene2ImperativeStyle();
  }
  
  private void initScene1DeclarativeStyle() {
    scene1 = SceneBuilder.create()
      .root(
        VBoxBuilder.create().spacing(8).alignment(Pos.CENTER).children(
          TextBuilder.create().text("Scene 1").build(),
          ButtonBuilder.create().text("Goto Scene 2").onAction(
            new EventHandler<ActionEvent> () {
              public void handle(ActionEvent t) {
                stage.setScene(scene2);
              }
            }
          ).build()
        ).build()
      ).build();    
  }
  
  private void initScene2ImperativeStyle() {
    VBox content = new VBox(8);
    content.setAlignment(Pos.CENTER);
    
    Text text = new Text("Scene 2");
    
    Hyperlink link = new Hyperlink("Goto Scene 1");
    link.setOnAction(new EventHandler<ActionEvent>() {
      public void handle(ActionEvent t) {
        stage.setScene(scene1);
      }
    });

    content.getChildren().addAll(text, link);
    
    scene2 = new Scene(content);
  }
  
}
