﻿// cc-by 3.0 Austria, (c) 2011 Markus Loeberbauer
// http://ssw.jku.at/Teaching/Lectures/SpezialLVA/JavaFX/
import javafx.application.Application;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.transform.Scale;
import javafx.stage.Stage;

public class ShowImage extends Application {
  private Scene scene;
  private Image image;
  private Scale imageViewScale;

  public static void main(String[] args) {
    Application.launch(args);
  }

  @Override
  public void start(Stage primaryStage) {
    primaryStage.setTitle("Show and scale image proportionaly");

    Group root = new Group();
    scene = new Scene(root, 300, 250);

    image = loadImage();
    ImageView imageView = new ImageView(image);
    imageViewScale = new Scale();
    imageView.getTransforms().add(imageViewScale);
    root.getChildren().add(imageView);

    ChangeListener<Number> updateImageView = new ChangeListener<Number>() {
      public void changed(ObservableValue<? extends Number> observable, Number oldValue, Number newValue) {
        updateImageSize();
      }
    };

    scene.widthProperty().addListener(updateImageView);
    scene.heightProperty().addListener(updateImageView);

    updateImageSize();
    
    primaryStage.setScene(scene);
    primaryStage.show();
  }

  private Image loadImage() {
    return new Image(getClass().getResourceAsStream("Image.jpg"));
  }

  private void updateImageSize() {
    double xRatio = scene.getWidth() / image.getWidth();
    double yRatio = scene.getHeight() / image.getHeight();

    double ratio = Math.min(xRatio, yRatio);

    imageViewScale.setX(ratio);
    imageViewScale.setY(ratio);
  }
}
